// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { cors } from '../../../lib/cors';

export default async function handler(req, res) 
{
	await cors(req, res);

	if(req.headers.cookie !== undefined)
	{
		const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");

		console.log("req.body");
		console.log(req.body);

		if(cookies.jwt !== undefined && cookies.jwt !== null)
		{
			console.log("cookies.jwt");
			console.log(cookies.jwt);

			var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
			var crm_jwt = jwt.sign(client_jwt_decoded, process.env.JWT_SECRET_CRM, { noTimestamp: true });

			console.log("client_jwt_decoded", client_jwt_decoded);
			console.log("crm_jwt", crm_jwt);

			console.log(`${ process.env.CRM_API_HOST }/lk/Contract/GetSchedulePayments`);

			try
			{
				await axios.get(`${ process.env.CRM_API_HOST }/lk/Contract/GetSchedulePayments`, {
					params: { ...client_jwt_decoded, contract_number: req.body.number }, 
					headers: {
						"Authorization": `Bearer ${ crm_jwt }`, 
					}, 
					withCredentials: true, 
				})
				.then((crm_response) => 
				{
					console.log("API", "contract", "crm_response.data");
					//console.log("API", "contract", crm_response.data);

					res.status(200).json(crm_response.data);
				})
				.catch((error) => 
				{
					console.error(error);
					res.status(500);
				});
			}
			catch(e)
			{
				console.error(e);
				res.status(500);
			}
		}
		else
		{
			res.status(403);
		}
	}
}